bloc1:				;dbut de la fonction exec

	movem.l d1-d7/a0-a6,-(a7)

	move.w #$700,d0
	trap #1

	move.l 56(a7),a6		;met l'adresse du programme appel dans a6
	subq.l #4,a6		;pour que a6 pointe sur "Bsr ..."

	bsr reloc2			;reloc le prog  partir de son adresse dans a6
	tst.w d0
	bne erreur

	move.b nbprog(pc),d0
	beq sauve		;sauvegarde cran et diffrentes valeurs
retoursauve:

	lea nbprog(pc),a4	;dit qu'un programme en plus est en cours d'utilisation
	addq.b #1,(a4)

	clr.w d0
	trap #1

	move.l a6,-(a7)
	add.w 12(a6),a6		;met adresse de dbut de prog dans a6 (a6+_main->a6)

	jsr (a6)		;excute le programme

	move.w #$700,d0
	trap #1

	move.l (a7)+,a6

	bsr unreloc2

	lea nbprog(pc),a4	;un prog en moins est en cours d'utilisation
	subq.b #1,(a4)

	beq restaure		;remet cran et interrrupts si dernier prog
retourrestaure:

	move.l message(pc),d0
	beq pasplant
	move.l d0,-(a7)
	bra showhelp

pasplant:
stop:

	move.l d0,-(a7)

	moveq #2,d7
	bsr touslesASM

	movem.l (a7)+,d0-d7/a0-a6

	addq.l #4,a7		;efface le BSR initial
	RTS

erreur:
err1:
	cmp.w #1,d0
	bne err2
	pea mmemory(pc)
err2:
	cmp.w #2,d0
	bne err3
	lea mlibrairie(pc),a1
	move.l (a0)+,(a1)+
	move.l (a0)+,(a1)+
	pea mpastrouve(pc)
err3:
	cmp.w #3,d0
	bne showhelp
	lea mmauvaise(pc),a1
	move.l (a0)+,(a1)+
	move.l (a0)+,(a1)+
	pea mwrong(pc)
showhelp:
	ROM_CALL ST_showHelp
	addq.l #4,a7
	bra stop

reloc:
	move.l a6,-(a7)
	move.w d0,-(a7)
	ROM_CALL HeapDeref
	addq.l #2,a7
	lea 2(a0),a6
	bsr reloc2
	move.l (a7)+,a6
	RTS

reloc2:
	lea -60(a7),a7		;laisse une place de 60 octets pour ErrorFrame
	move.l a7,-(a7)
	ROM_CALL ER_catch		;protection anti-crash de la relocation
	tst.w d0
	beq suitereloc2		;la relocation s'est faite sans erreur

	jsr (a4)			;rappelle ER_catch

	tst.w d0
	bne finreloc2		;d0 contient le message  afficher

	bsr bloc3			;unreloc ce qui a t commenc, puis redclenche l'erreur
suitereloc2:

	bsr bloc2		;fait la relocation du programme

	ROM_CALL ER_success
finreloc2:
	move.l a1,a0	;a1 = adresse de la lib
	lea 64(a7),a7
	RTS

bloc2:
;partie1 -> librairies
	movem.l d0-d7/a0-a6,-(a7)

	cmp.b #1,$10(a6)
	beq finbloc2		;pour viter de relocer une lib en cours

	addq.w #1,8(a6)
	cmp.w #1,8(a6)
	bne finbloc2		;est dj reloqu, se contente de +1

	move.l a6,-(a7)
	subq.l #2,(a7)
	ROM_CALL HeapPtrToHandle
	move.w d0,-(a7)
	ROM_CALL HeapLock
	addq.l #6,a7

	lea $1A(a6),a5		;a5 pointe sur l'Import Table

	move.w (a5)+,d7		;nombre de librairies utilises dans d7
	beq partie2		;si aucune, passe  la suite

	move.w d7,d3
	mulu.w #10,d3		;d3=10*d7

	lea 0(a5,d3.w),a3	;a3 = liste d'offset des librairies utilises

bouclelibrairie:

	bsr find		;a5 = nom de la lib cherche
				;a0 = adresse de la lib trouve
				;d0 = 0 si a pas trouv

	tst.l d0
	bne bonnelib

	dc.w $A002

bonnelib:

	move.b #1,$10(a6)		;marque que la lib est dj en cours de reloc

;initialiser la librairie (tout + sous-lib si besoin est)
	exg.l a0,a6
	bsr bloc2
	exg.l a0,a6

	clr.b $10(a6)	;n'est plus en cours de reloc

	move.l a0,a1
	add.w $16(a1),a1	;adresse de l'export table de la librairie dans a1

	move.w (a1)+,d4		;nombre de fonctions dans d4

	move.w (a3)+,d3		;nombre de fonctions utilises dans d3

bouclefonctionlibrairie:

	clr.l d2		;au cas o d2>$FFFF

	move.w (a3)+,d2		;numro de la fonction dans d2

	cmp.w d4,d2
	blt fonctioninclue

	dc.w $A003			;mauvaise version

fonctioninclue:
	lsl.w #1,d2		;d2*2 -> d2

	move.w 0(a1,d2.w),d2	;offset de la fonction dans d2

	move.l a0,d1		;adresse de la lib dans d1
	add.l d2,d1		;adresse de la fonction dans d1


boucleoffsetlibrairie:
	move.w (a3)+,d0		;offset dans d0
	beq finserieoffset

	add.l d1,0(a6,d0.w)
	bra boucleoffsetlibrairie

finserieoffset:
	dbra d3,bouclefonctionlibrairie

nepastoucher:

	lea 10(a5),a5		;pour chercher prochaine librairie

	subq.w #1,d7
	bne bouclelibrairie	;tant qu'il en reste, continue

	move.l a3,a5

partie2:
;partie2 -> fonctions en ROM

	move.w (a5)+,d1		;y a t il des fonctions appeles ?
	beq partie3

	move.w (a5)+,d1		;nb de fonctions diffrentes utilises


boucle1:			;sert  placer l'adresse dans d2

	move.w (a5)+,d2		;numro de la fonction dans d2


	lsl.w #2,d2		;d2*4 -> d2

	move.l $C8,a4		;adresse table ROM dans (a4)
	move.l 0(a4,d2.w),d2	;adresse de la fonction dans d2


boucle2:

	move.w (a5)+,d3		;met offset dans d3
	beq finROM		;si offset=0, fonction suivante

	add.l d2,0(a6,d3.w)	;place l'adresse au bon endroit

	bra boucle2

finROM:
	dbra d1,boucle1

partie3:			;RAM relocation table

	move.w (a5)+,d1		;des valeurs en RAM?
	beq partie4

	move.w (a5)+,d1		;qt de valeurs

fonctionRAM:

	move.w (a5)+,d2
	lsl.l #2,d2		;d2*4 car valeurs = adresses ou longs mots

	btst #16,d2		;regarde si EXTRA_RAM_ADDRESS
	bne extra

	lea valeursRAM(pc),a4	;dbut de la table des valeurs dans a4
	move.l 0(a4,d2.w),d4	;valeur dans d4
	bra boucleoffsetRAM

extra:
	move.w $18(a6),d0		;offset de l'EXTRA_RAM_TABLE
	lea 0(a6,d0.w),a4		;adresse de l'EXTRA_RAM_TABLE
	add.w d2,a4			;pointe sur la bonne valeur
	clr.l d4
	move.w (a4)+,d4		;valeur pour la 89
	move.b CALC(pc),d0
	beq boucleoffsetRAM
	move.w (a4),d4		;valeur pour la 92+

boucleoffsetRAM:

	move.w (a5)+,d3
	beq finRAM

	btst #17,d2
	bne mot			;et pas beq!

	add.l d4,0(a6,d3.w)
	bra boucleoffsetRAM

mot:
	add.w d4,0(a6,d3.w)
	bra boucleoffsetRAM
finRAM:
	dbra d1,fonctionRAM


partie4:
;partie4 -> relocation table (les variables)

	move.l a6,d2	;adresse de dbut de programme dans d2

bouclereloc:
	move.w (a5)+,d3	;offset dans d3
	beq finbouclereloc

	add.l d2,0(a6,d3.w)

	bra bouclereloc

finbouclereloc:

;partie5 -> BSS

	move.w $14(a6),d0		;offset de l'handle table
	beq finBSS

	lea 0(a6,d0.w),a5		;adresse de l'handle table dans a5

	move.l (a5)+,-(a7)	;empile taille du bloc
	ROM_CALL HeapAllocThrow

	move.w d0,$12(a6)		;met l'handle  sa place

	move.w d0,-(a7)
	ROM_CALL HLock
	addq.l #6,a7		;2+4

	move.l a0,d2		;adresse du bloc BSS dans d2

boucleBSS:
	move.w (a5)+,d3
	beq finBSS

	add.l d2,0(a6,d3.w)

	bra boucleBSS

finBSS:
finbloc2:
	movem.l (a7)+,d0-d7/a0-a6
	RTS

unreloc:
	move.l a6,-(a7)
	move.w d0,-(a7)
	ROM_CALL HeapDeref
	addq.l #2,a7
	lea 2(a0),a6
	bsr unreloc2
	move.l (a7)+,a6
	RTS

unreloc2:
bloc3:		;fonction unreloc (comme reloc, mais en inverse !)

	movem.l d0-d7/a0-a6,-(a7)

	cmp.b #2,$10(a6)
	beq finbloc3

	tst.w 8(a6)
	beq finbloc3

	subq.w #1,8(a6)
	bne finbloc3

	move.l a6,-(a7)
	subq.l #2,(a7)
	ROM_CALL HeapPtrToHandle
	move.w d0,-(a7)
	ROM_CALL HeapUnlock
	addq.l #6,a7

;dpartie1 -> librairies		;d pour dlocation

	lea $1A(a6),a5		;a5 pointe sur l'Import Table

	move.w (a5)+,d7		;nombre de librairies utilises dans d7
	beq dpartie2		;si aucune, passe  la suite

	move.w d7,d3
	mulu.w #10,d3		;d3=10*d7

	lea 0(a5,d3.w),a3	;a3 = liste d'offset des librairies utilises

dbouclelibrairie:

	bsr find		;a5 = nom de la lib cherche
				;a0 = adresse de la lib trouve
				;d0 = 0 si a rien trouv

	tst.l d0
	bne dbonnelib

	move.l a5,a1	;sauve le nom de la lib  problme
	dc.w $A002		;lib non trouve

dbonnelib:

	move.b #2,$10(a6)		;en cours de deloc

;initialiser la librairie (tout + sous-lib si besoin est)
	exg.l a0,a6
	bsr bloc3
	exg.l a0,a6

dnepasinitialiser:

	clr.b $10(a6)

	move.l a0,a1

	add.w $16(a1),a1	;adresse de l'export table de la librairie dans a1

	move.w (a1)+,d4		;nombre de fonctions dans d4

	move.w (a3)+,d3		;nombre de fonctions utilises dans d3

dbouclefonctionlibrairie:

	clr.l d2		;au cas o d2>$FFFF

	move.w (a3)+,d2		;numro de la fonction dans d2

	cmp.w d4,d2
	blt dfonctioninclue

	move.l a5,a1
	dc.w $A003

dfonctioninclue:
	lsl.w #1,d2		;d2*2 -> d2

	move.w 0(a1,d2.w),d2	;offset de la fonction dans d2

	move.l a0,d1		;adresse de la lib dans d1
	add.l d2,d1		;adresse de la fonction dans d1


dboucleoffsetlibrairie:
	move.w (a3)+,d0		;offset dans d0
	beq dfinserieoffset

	sub.l d1,0(a6,d0.w)	;et pas move
	bra dboucleoffsetlibrairie

dfinserieoffset:
	dbra d3,dbouclefonctionlibrairie

dnepastoucher:

	lea 10(a5),a5		;pour chercher prochaine librairie

	subq.w #1,d7
	bne dbouclelibrairie	;tant qu'il en reste, continue

	move.l a3,a5


dpartie2:
;partie2 -> fonctions en ROM

	move.w (a5)+,d1		;y a t il des fonctions appeles ?
	beq dpartie3

	move.w (a5)+,d1		;nb de fonctions diffrentes utilises


dboucle1:			;sert  placer l'adresse dans d2

	move.w (a5)+,d2		;numro de la fonction dans d2

	lsl.w #2,d2		;d2*4 -> d2

	movea.l $C8,a4		;adresse table ROM dans (a4)
	move.l 0(a4,d2.w),d2	;adresse de la fonction dans d2


dboucle2:

	move.w (a5)+,d3		;met offset dans d3
	beq dfinROM		;si offset=0, fonction suivante


	sub.l d2,0(a6,d3.w)	;place l'adresse au bon endroit

	bra dboucle2

dfinROM:
	dbra d1,dboucle1


dpartie3:			;RAM relocation table

	move.w (a5)+,d1		;des valeurs en RAM?
	beq dpartie4

	move.w (a5)+,d1		;qt de valeurs

dfonctionRAM:

	move.w (a5)+,d2
	lsl.l #2,d2		;d2*4 car valeurs = adresses ou longs mots

	btst #16,d2		;regarde si EXTRA_RAM_ADDRESS
	bne dextra

	lea valeursRAM(pc),a4	;dbut de la table des valeurs dans a4
	move.l 0(a4,d2.w),d4	;valeur dans d4
	bra dboucleoffsetRAM

dextra:
	move.w $18(a6),d0		;offset de l'EXTRA_RAM_TABLE
	lea 0(a6,d0.w),a4		;adresse de l'EXTRA_RAM_TABLE
	add.w d2,a4			;pointe sur la bonne valeur
	clr.l d4
	move.w (a4)+,d4		;valeur pour la 89
	move.b CALC(pc),d0
	beq dboucleoffsetRAM
	move.w (a4),d4		;valeur pour la 92+

dboucleoffsetRAM:

	move.w (a5)+,d3
	beq dfinRAM

	btst #17,d2
	bne dmot			;et pas beq!

	sub.l d4,0(a6,d3.w)
	bra dboucleoffsetRAM

dmot:
	sub.w d4,0(a6,d3.w)
	bra dboucleoffsetRAM
dfinRAM:
	dbra d1,dfonctionRAM

dpartie4:
;partie4 -> relocation table (les variables)

	move.l a6,d2	;adresse de dbut de programme dans d2

dbouclereloc:
	move.w (a5)+,d3	;offset dans d3
	beq dfinbouclereloc

	sub.l d2,0(a6,d3.w)


	bra dbouclereloc

dfinbouclereloc:

;dpartie5 -> BSS

	move.w $14(a6),d0
	beq dfinBSS

	move.w $12(a6),d0		;regarde s'il y a un handle
	bne peuteffacer

	dc.w $A001			;erreur numro1: pas de mmoire

peuteffacer:
	move.w d0,-(a7)
	ROM_CALL HeapDeref

	move.l a0,d6		;adresse du bloc BSS dans d6

	ROM_CALL HeapFree
	addq.l #2,a7

	clr.w $12(a6)		;efface l'handle

	addq.l #4,a5		;saute la taille du bloc!

dboucleBSS:
	move.w (a5)+,d3
	beq dfinBSS

	sub.l d6,0(a6,d3.w)

	bra dboucleBSS

dfinBSS:
finbloc3:
	movem.l (a7)+,d0-d7/a0-a6
	RTS

find:		;si trouve, a0=dbut du fichier
		;a5 = nom de la lib cherche

	movem.l d1-d7/a1-a6,-(a7)	;ne pas toucher  a3,a5,a6,d3,d7 !

	move.l (a5)+,d3
	move.l (a5),d4

	move.w valeursRAM+18*4+2(pc),-(a7)	;tios::FolderListHandle
	ROM_CALL HeapDeref
	addq.l #2,a7
	lea 2(a0),a6
	move.w (a6),d7		;nombre de folders
	subq.w #1,d7		;pour DBRA
loopfolder:
	lea 14(a6),a6		;passe au prochain folder
	move.w (a6),-(a7)
	ROM_CALL HeapDeref
	addq.l #2,a7
	addq.l #2,a0
	move.w (a0)+,d6
	beq folderempty
	subq.w #1,d6		;pour DBRA
loopfile:
	cmp.l (a0),d3
	bne suivant
	cmp.l 4(a0),d4
	bne suivant

	bsr verif
	tst.w d0
	beq suivant

	move.l a0,a5		;sauve l'index si pas assez de mem
	move.w 12(a0),-(a7)
	ROM_CALL HeapDeref
	addq.l #2,a7

	btst #1,10(a5)
	beq trouv	;pas archiv : c'est bon

;le copie en RAM

	move.l a0,a3		;sauve l'adresse de la lib
	clr.l d5
	move.w (a0),d5
	addq.l #3,d5		;taille + 3
	move.l d5,-(a7)
	ROM_CALL HeapAlloc
	addq.l #4,a7

	move.l a5,a0	;restaure l'index au cas o
	tst.w d0
	beq suivant		;pas assez de mem pour le copier

	addq.l #8,a0
	move.w 4(a0),(a0)+	;sauvegarde l'ancien handle
	move.w d0,2(a0)		;met le nouveau

	bset #6,(a0)		;attribut= copi
	bclr #1,(a0)

	move.w d0,-(a7)
	ROM_CALL HLock
	addq.l #2,a7

	move.l a0,a1

	subq.w #1,d5	;pour DBRA
copietemp:
	move.b (a3)+,(a1)+
	dbra d5,copietemp

	bra trouv

suivant:
	lea 14(a0),a0
	dbra d6,loopfile
folderempty:
	dbra d7,loopfolder

	clr.l d0
trouv:
	addq.l #2,a0
	movem.l (a7)+,d1-d7/a1-a6
	RTS

verif:
	move.l a0,-(a7)
	move.w 12(a0),-(a7)
	ROM_CALL HeapDeref
	addq.l #2,a7

	move.w (a0)+,d0
	cmp.b #$F3,-1(a0,d0.w)
	bne pasbon

	cmp.l #'68kL',4(a0)
	beq bon
	cmp.l #'68kP',4(a0)
	beq bon
pasbon:
	clr.w d0
bon:
	move.l (a7)+,a0
	RTS


sauve:

	lea handle(pc),a5
	move.l #3840,-(a7)
	ROM_CALL HeapAlloc	;cre bloc pour sauvegarder l'cran
	addq.l #4,a7
	move.w d0,(a5)
	bne OK
	bsr unreloc2
	moveq #1,d0			;pas assez de mmoire
	bra erreur
OK:
	move.w d0,-(a7)
	ROM_CALL HeapDeref	;met l'adresse du bloc dans a0
	addq.l #2,a7
	lea $4C00,a1		;met l'adresse de l'cran dans a1
	move.w #3840/4-1,d1
sauveecran:
	move.l (a1)+,(a0)+
	dbra d1,sauveecran

	lea routine1(pc),a0
	lea $40008,a1

	moveq #6,d0
changeinterrupt:
	move.l a0,(a1)+
	addq.l #6,a0
	dbra d0,changeinterrupt

	addq.l #8,a1
	move.l a0,(a1)		;met routine8  $2C
	addq.l #6,a0

	lea $34(a1),a1
	move.l a0,(a1)		;puis routine9  $60
	addq.l #6,a0

	lea $1C(a1),a1
	move.l a0,(a1)		;routine10  $7C

	subq.l #4,a1		;auto-int6  $78
	lea oldint6(pc),a0
	move.l (a1),(a0)
	lea newint6(pc),a0
	move.l a0,(a1)

	move.l valeursRAM+17*4(pc),a0		;tios::Heap
	move.l (a0),a0
	moveq #127,d7
loophandle:
	addq.w #1,d0	;prend en compte que c'tait sur -1 avant
	tst.l (a0)+
	bne loophandle

	move.w d0,-(a7)
	dbra d7,loophandle

	lea message(pc),a5
	clr.l (a5)+		;part du principe que a va pas planter...
;	lea pointeur(pc),a5
	move.l a7,(a5)

	bra retoursauve


restaure:
	move.w handle(pc),-(a7)
	ROM_CALL HeapDeref	;redemande l'adresse du bloc cran
	lea $4C00,a1		;adresse de l'cran en a1
	move.w #3840/4-1,d1
restaureecran:
	move.l (a0)+,(a1)+
	dbra d1,restaureecran
	ROM_CALL HeapFree
	addq.l #2,a7

	lea $40000,a1
	move.l valeursRAM+12(pc),a2	;ROM_base
	add.l #$12088,a2

	moveq #8,d0
remetinterrupt:
	move.l (a2)+,(a1)+
	dbra d0,remetinterrupt

	addq.l #8,a1
	addq.l #8,a2
	move.l (a2)+,(a1)+

	lea $30(a1),a1
	lea $30(a2),a2

	moveq #9,d0
remetinterrupt2:
	move.l (a2)+,(a1)+
	dbra d0,remetinterrupt2

;routine pour librer les handles

	moveq #127,d7
freeloop:
	ROM_CALL HeapDeref
	move.l a0,d0
	beq libre

;regarde si handle est dans la VAT

	move.w (a7),d6	;handle
	move.w #$A,-(a7)
	clr.l -(a7)
	ROM_CALL SymFindFirst
	cmp.w 12(a0),d6
	beq dedans
searchloop:
	ROM_CALL SymFindNext
	move.l a0,d0
	beq pasdedans
	cmp.w 12(a0),d6
	bne searchloop
dedans:
	st.b d0		;dedans, ne pas toucher!
pasdedans:
	addq.l #6,a7

	tst.b d0
	bne libre
	ROM_CALL HeapFree
libre:
	addq.l #2,a7
	dbra d7,freeloop

	bra retourrestaure

touslesASM:
	move.w #$A,-(a7)
	clr.l -(a7)

	ROM_CALL SymFindFirst
ASMloop:
	ROM_CALL SymFindNext
	move.l a0,d0
	beq finASM

	bsr verif		;si ASM -> non-nul
	tst.w d0
	beq ASMloop

	cmp.w #2,d7
	bne pasfreeASM

	move.l a0,a6
	btst #6,10(a6)
	beq ASMloop		;n'a pas l'attribut "copi"

	move.w 12(a6),-(a7)
	ROM_CALL HeapDeref
	addq.l #2,a7
	tst.w 10(a0)
	bne ASMloop		;encore utilis

	move.w 12(a6),-(a7)
	ROM_CALL HeapFree
	addq.l #2,a7

	addq.l #8,a6
	move.w (a6)+,2(a6)		;remet le bon handle
	bset #1,(a6)		;remet l'attribut "archiv"
	bclr #6,(a6)		;enlve celui "copi"
	bra ASMloop

pasfreeASM:

	move.w 12(a0),-(a7)
	ROM_CALL HeapDeref
	addq.l #2,a7
	addq.l #2,a0

	tst.w d7		;faire _exit ou unreloc ?
	bne unrelocASM
exitASM:
	move.w 8(a0),d0
	beq ASMloop		;regarde dj si a servi
	move.w $E(a0),d0
	beq ASMloop		;n'a pas de _exit

	jsr 0(a0,d0.w)	;fais le _exit
	bra ASMloop
unrelocASM:
	move.l a0,a6
	move.w 8(a6),d0
unrelocloop:
	bsr unreloc2	;le fais autant de fois qu'il le faut
	dbra d0,unrelocloop

	bra ASMloop
finASM:
	addq.l #6,a7
	RTS

plantage:
	move	#$2700,SR	;pour pas tre emmerd par ESC+ON..
	lea message(pc),a0
	move.l a1,(a0)	;sauvegarde l'adresse du message
	move.w #$4C00/8,$600010	;remet le bon cran

	lea nbprog(pc),a0
	clr.b (a0)

	lea restaure(pc),a0
	move.l a0,2(a7)	;le fera retourner ici
	move.w #$700,(a7)		;avec les ints dsactives

	move.l pointeur(pc),a0
	move a0,USP

;fait tous les exits points

	clr.l d7
	bsr touslesASM

;unreloc tous les ASM

	moveq #1,d7
	bsr touslesASM

	RTE

routine1:
	lea bus(pc),a1
	bra plantage
routine2:
	lea address(pc),a1
	bra plantage
routine3:
	lea illegal(pc),a1
	bra plantage
routine4:
	lea divide(pc),a1
	bra plantage
routine5:
	lea chk(pc),a1
	bra plantage
routine6:
	lea trapv(pc),a1
	bra plantage
routine7:
	lea privilege(pc),a1
	bra plantage
routine8:
	lea line11(pc),a1
	bra plantage
routine9:
	lea spurious(pc),a1
	bra plantage
routine10:
	lea autoint7(pc),a1
	bra plantage


valeursRAM ds.l 21	;il y a 21 valeurs  stocker
CALC dc.b 0
nbprog dc.b 0

handle dc.w 0	;pour l'cran
message ds.l 1	;le message caus par le crash
pointeur ds.l 1	;sauvegarde a7


mpastrouve dc.b "Library not found:"
mlibrairie ds.b 9		;8 lettres et un 0
mwrong dc.b "New version needed:"
mmauvaise ds.b 9
mmemory dc.b "Out of memory",0

bus dc.b "Bus Error",0			;$8
address dc.b "Address Error",0
illegal dc.b "Illegal Instruction",0	;$10
divide dc.b "Divide by Zero",0
chk dc.b "CHK Instruction",0		;$18
trapv dc.b "TRAPV Instruction",0
privilege dc.b "Privilege Violation",0	;$20

line11 dc.b "Line 1111 Emulator",0	;$2C

spurious dc.b "Spurious Interrupt",0	;$60

autoint7 dc.b "Protected memory violation",0	;$7C

escapeon dc.b "Aborted by pressing [ESC]+[ON]",0	;$78