
	include "tios.h"

	xdef _library
	xdef _ti89
	xdef _ti92plus
	xdef _exit	;indispensable pour gray4 !!!

	xdef graphlib@0000	;fill		;OK
	xdef graphlib@0001	;put_sprite	;OK
	xdef graphlib@0002	;smallbox	;OK
	xdef graphlib@0003	;box		;OK
	xdef graphlib@0004	;frame	;OK
	xdef graphlib@0005	;clr_scr	;OK
	xdef graphlib@0006	;vert		;OK
	xdef graphlib@0007	;horiz	;OK
	xdef graphlib@0008	;bigbox	;OK
	xdef graphlib@0009	;scrtomem	;OK
	xdef graphlib@000A	;memtoscr	;OK
	xdef graphlib@000B	;put_sprite_mask	;OK
	xdef graphlib@000C	;put_sprite2	;OK
	xdef graphlib@000D	;choosescreen	;OK
	xdef graphlib@000E	;gray2	;OK
	xdef graphlib@000F	;gray4	;OK
	xdef graphlib@0010	;gray7	;OK
	xdef graphlib@0011	;plane0	;OK
	xdef graphlib@0012	;plane1	;OK
	xdef graphlib@0013	;plane2	;OK
	xdef graphlib@0014	;clr_scr2		;OK
	xdef graphlib@0015	;show_dialog	;OK
	xdef graphlib@0016	;clear_dialog	;OK
	xdef graphlib@0017	;line		;OK
	xdef graphlib@0018	;erase_rect	;OK
	xdef graphlib@0019	;frame_rect	;OK
	xdef graphlib@001A	;getlength	;OK


graphlib@0000
fill:
;Input:	d0.w = x
;	d1.w = y
;	d2.w = width
;	d3.w = height
;	d4.w = color:	0 -> Video Invert
;			1 -> White
;			2 -> Black

	movem.l d0-d4,-(a7)
	add.w d0,d2		;pour obtenir x2
	exg d3,d4
fillhoriz:
	bsr horiz
	addq.w #1,d1
	dbra d4,fillhoriz
	movem.l (a7)+,d0-d4
	RTS

graphlib@0001
put_sprite:
	movem.l d6-d7/a2,-(a7)

	move.w (a0),d6
	move.w 2(a0),d7
	mulu.w d6,d7
	lea 4(a0,d7.w),a2
	bsr put_sprite2

	movem.l (a7)+,d6-d7/a2
	RTS

graphlib@0002
smallbox:
	movem.l	d0-d3,-(a7)
	moveq #25,d0
	moveq #20,d1
	moveq #110,d2
	moveq #60,d3
	tst.b CALCULATOR
	beq small89
	moveq #40,d0
	moveq #25,d1
	move.w #158,d2
	moveq #76,d3
small89:
	bsr box
	movem.l	(a7)+,d0-d3
	RTS

graphlib@0003
box:
;Input: d0.w = x
;	d1.w = y
;	d2.w = width
;	d3.w = height
;	a0.l = title of the box
	movem.l	d0-d7/a0-a6,-(a7)
	moveq #1,d4		;en blanc
	bsr fill

	move.w d2,d4
	move.w d3,d5
	addq.w #1,d4
	addq.w #1,d5

	bsr commun2

	move.w d4,d2
	moveq #8,d3
	moveq #2,d4		;en noir
	bsr fill		;le cadre noir en haut

	addq.w #2,d0
	addq.w #2,d1

	movem.l d0-d1/a0,-(a7)
	clr.w -(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
	move.w d0,d7
	movem.l (a7)+,d0-d1/a0

	WriteStrA d0,d1,#2,a0

	move.w d7,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7

	movem.l	(a7)+,d0-d7/a0-a6
	RTS

commun2:
	bsr frame

	addq.w #1,d0
	addq.w #1,d1
	subq.w #2,d4
	subq.w #2,d5
	bsr frame

	addq.w #2,d0
	addq.w #2,d1
	subq.w #4,d4
	subq.w #4,d5
	bsr frame
	RTS

graphlib@0004
frame:
;Input: d0.w = x
;	d1.w = y
;	d4.w = width
;	d5.w = height
	movem.l	d0-d5,-(a7)
	moveq #2,d3	;pour faire du noir

	move.w d0,d2	;pour x2
	add.w d4,d2
	bsr horiz
	add.w d5,d1
	bsr horiz

	sub.w d5,d1
	move.w d1,d2
	add.w d5,d2
	bsr vert
	add.w d4,d0
	bsr vert

	movem.l	(a7)+,d0-d5
	RTS

graphlib@0005
clr_scr:
	movem.l	d0/a1,-(a7)
	bsr screen
	move.l #3840/4-1,d0
zap:
	clr.l (a1)+
	dbra d0,zap
	movem.l	(a7)+,d0/a1
	RTS

graphlib@0006
vert:
;Input:	d0.w = x
;	d1.w = y1
;	d2.w = y2
	movem.l	d0-d4/a1,-(a7)
	cmp.w d1,d2
	bgt plus
	exg d1,d2
plus:
	sub.w d1,d2	;hauteur
	bsr commun
lignevert:
	bset d0,(a1)
	lea 30(a1),a1
	dbra d2,lignevert
	movem.l	(a7)+,d0-d4/a1
	RTS

commun:
	bsr screen
;	lsl.w #1,d1
	add.w d1,d1
	move.w d1,d4
	lsl.w #4,d1
	sub.w d4,d1		;x*30
	move.w d0,d4
	lsr.w #3,d4
	add.w d4,d1
	add.w d1,a1
	not.b d0
	andi.b #7,d0
	RTS

graphlib@0007
horiz:
;Input:	d0.w = x1
;	d1.w = y
;	d2.w = x2
;	d3.w = color  	0 -> Video Invert
;			1 -> White
;			2 -> Black
	movem.l	d0-d4/a1,-(a7)
	cmp.w d0,d2
	bgt plush
	exg d0,d2
plush:
	sub.w d0,d2		;largeur
	bsr commun

debut:
	tst.b d3
	beq debutchange
	cmp.b #1,d3
	beq debutblanc

debutnoir:
	bset d0,(a1)
	subq.w #1,d2
	bmi fini
	dbra d0,debutnoir
	addq.l #1,a1
milieunoir:
	subq.w #8,d2
	blt fin
	st.b (a1)+
	bra milieunoir

debutchange:
	bchg d0,(a1)
	subq.w #1,d2
	bmi fini
	dbra d0,debutchange
	addq.l #1,a1
milieuchange:
	subq.w #8,d2
	blt fin
	not.b (a1)+
	bra milieuchange

debutblanc:
	bclr d0,(a1)
	subq.w #1,d2
	bmi fini
	dbra d0,debutblanc
	addq.l #1,a1
milieublanc:
	subq.w #8,d2
	blt fin
	clr.b (a1)+
	bra milieublanc

fin:
	moveq #7,d0
	addq.w #8,d2
	bra debut
fini:
	movem.l	(a7)+,d0-d4/a1
	RTS

graphlib@0008
bigbox:
	movem.l d0-d3,-(a7)
	clr.w d0
	clr.w d1
	move.w #LCD_WIDTH-2,d2
	move.w #LCD_HEIGHT-8,d3
	bsr box
	movem.l (a7)+,d0-d3
	RTS
graphlib@0009
scrtomem:
;Input:	d0.w = X of top left-hand corner in bytes(0<X<30)
;	d1.w = Y of top left-hand corner (0<Y<128)
;	d2.w = width in bytes (0<d2<30)  
;	d3.w = height (0<d3<128)         
;
;Output: d4.w = handle to the memory containg the part of the screen.

	movem.l d0-d3/d5-d7/a0-a6,-(a7)
	movem.l d0-d3,-(a7)
	mulu.w d2,d3
	move.l d3,-(a7)
	jsr tios::HeapAlloc
	addq.l #4,a7
	move.w d0,-(a7)
	jsr tios::HeapDeref
	move.w (a7)+,d4
	movem.l (a7)+,d0-d3
	bsr screen
	mulu.w #30,d1
	add.w d0,d1
	add.w d1,a1

	subq.w #1,d2	;pour les DBRA
	subq.w #1,d3
rangee:
	move.w d2,d5
	move.l a1,a2
copielargeur:
	move.b (a2)+,(a0)+
	dbra d5,copielargeur
	lea 30(a1),a1
	dbra d3,rangee

	movem.l (a7)+,d0-d3/d5-d7/a0-a6
	RTS

graphlib@000A
memtoscr:
;Input:	d0.w = X of top left-hand corner in bytes(0<X<30)
;	d1.w = Y of top left-hand corner (0<Y<128)
;	d2.w = width in bytes (0<d2<30)
;	d3.w = height (0<d3<128)
;	d4.w = handle previously created by memtoscr(containing the
;					part of the screen to restore)

	movem.l d0-d7/a0-a6,-(a7)

	move.w d4,d5
	DEREF d5,a0

	bsr screen

	mulu.w #30,d1
	add.w d0,d1
	add.w d1,a1

	subq.w #1,d2	;pour les DBRA
	subq.w #1,d3
rangee2:
	move.w d2,d5
	move.l a1,a2
copielargeur2:
	move.b (a0)+,(a2)+
	dbra d5,copielargeur2
	lea 30(a1),a1
	dbra d3,rangee2

	move.w d4,-(a7)
	jsr tios::HeapFree
	addq.l #2,a7

	movem.l (a7)+,d0-d7/a0-a6

	RTS

graphlib@000B
put_sprite_mask:
	movem.l d0-d7/a0-a6,-(a7)
	move.w (a0)+,d6	;hauteur en pixels
	move.w (a0)+,d7	;largeur en octets
	subq.w #1,d6	;pour les DBRA
	subq.w #1,d7

	bsr commun

	addq.b #1,d0	;pour viter un dcalage  droite

	clr.w d4
	move.b d3,d4
	lsl.w d0,d4

toutsprite:
	move.w d7,d5
	move.l a1,a3
lignesprite:
	move.w d4,d3
	bsr afficheoctet
	dbra d5,lignesprite
	lea 30(a1),a1
	dbra d6,toutsprite

	movem.l (a7)+,d0-d7/a0-a6
	RTS

afficheoctet:
;	d0=dcalage
;	d2=bout du sprite
;	d3=masque
;	a3=adresse de l'cran

	clr.w d2
	move.b (a0)+,d2
	lsl.w d0,d2

	move.b (a3)+,d1	;pour viter une jolie "Address Error"
	lsl.w #8,d1
	move.b (a3),d1

	or.w d2,d1		;affiche les pixels

	not.w d3
	or.w d3,d2		;seuls les 0 qui doivent tre affichs restent des 0
	and.w d2,d1		;efface...

	move.b d1,(a3)
	lsr.w #8,d1
	move.b d1,-1(a3)

	RTS

graphlib@000C
put_sprite2:
	movem.l d0-d7/a0-a6,-(a7)
	move.w (a0)+,d6	;hauteur en pixels
	move.w (a0)+,d7	;largeur en octets
	subq.w #1,d6	;pour les DBRA
	subq.w #1,d7

	bsr commun

	addq.b #1,d0	;pour viter un dcalage  droite

toutsprite2:
	move.w d7,d5
	move.l a1,a3
lignesprite2:
	clr.w d3
	move.b (a2)+,d3
	lsl.w d0,d3
	bsr afficheoctet
	dbra d5,lignesprite2
	lea 30(a1),a1
	dbra d6,toutsprite2

	movem.l (a7)+,d0-d7/a0-a6

	RTS

graphlib@000E
gray2:
_exit:
        movem.l d0-d7/a0-a6,-(a7)       ;save copy of all registers on stack

      lea handle(pc),a6
	move.w (a6),d0
	beq graylib_fail		;vite plantage si libre bloc vide

	move.w d0,-(a7)
	jsr tios::HeapFree
	addq.l #2,a7

	clr.w (a6)+			;handle

	move.w (a6),d0		;dummyhandle
	beq suitegray2

	move.w d0,-(a7)
	jsr tios::HeapFree
	addq.l #2,a7

	clr.w (a6)

suitegray2:
	move.l #LCD_MEM,plane0
	move.l oldint1(pc),$40064        ;restore old auto-int 1
	jsr tios::PortRestore        ;tells tios to draw to LCD_MEM

graylib_fail:                           ;on error (not enough free mem)
        movem.l (a7)+,d0-d7/a0-a6       ;restore copy of registers from stack
	clr.l d0                        ;clear d0 (d0 = 0 indicates error)
	RTS                             ;return

graphlib@000F
gray4:	;thanks to Scott Noveck for his source

        movem.l d0-d7/a0-a6,-(a7)       ;save copy of all registers on stack

        move.l #3840*2+4,-(a7)    ;two planes + 4 bytes
        jsr tios::HeapAllocHigh          ;allocate memory
        addq.l #4,a7                     ;restore stack pointer

	move.w d0,handle               ;otherwise, d0 contains the handle
	beq graylib_fail                ;  then not enough free memory

        DEREF d0,a5                     ;get the address in a5

	move.w #30,(a5)+		;tios bitmap format - 30 bytes wide
	move.w #128,(a5)+		;tios bitmap format - 128 lines high
	move.w #127,-(a7)               ;push height-1
	move.w #239,-(a7)               ;push width-1

        move.l a5,-(a7)                ;push pointer to plane 0
	jsr tios::PortSet            ;portset tells tios to draw to plane 1
        addq.l #8,a7                     ;restore stack

        move.l a5,plane0               ;and save it

	lea 30*128(a5),a5                ;increase a5 to point to plane 1

        move.l a5,plane1		;save address of plane 1

	move.l $64,oldint1            ;save old auto-int 1 address
	move.l #int_1_g4,$40064               ;install new auto-int 1 routine
        movem.l (a7)+,d0-d7/a0-a6       ;restore registers from stack
	st.b d0	                        ;set true d0 (d0.b = $ff)
	RTS                             ;return successful!


graphlib@0010
gray7:		;impossible sur HW2 !

	bsr gray4

	move.l #3840,-(a7)
	jsr tios::HeapAllocHigh		;cre un bloc bidon

	move.w d0,dummyhandle

	move.w d0,-(a7)
	jsr tios::HeapDeref
	addq.l #6,a7

	move.l a0,plane2		;pourra crire n'importe quoi ici...

	RTS

graphlib@0014
clr_scr2:
	movem.l d0-d3,-(a7)
	bsr clr_scr
	clr.w d0
	move.w #LCD_HEIGHT-7,d1
	move.w #160,d2
	moveq #2,d3
	bsr horiz
	movem.l (a7)+,d0-d3
	RTS

graphlib@0015
show_dialog:
	movem.l d0-d7/a0-a6,-(a7)
	move.w (a6)+,d0
	move.w (a6)+,d1
	move.w (a6)+,d2
	move.w (a6)+,d3
	sub.w d0,d2		;largeur
	sub.w d1,d3		;hauteur
	lea dialogpos(pc),a5
	movem.w d0-d3,(a5)
	moveq #1,d4		;en blanc
	bsr fill
	move.w d2,d4
	move.w d3,d5
	addq.w #1,d0
	addq.w #1,d1
	subq.w #2,d4
	subq.w #2,d5
	bsr commun2
	move.w #2,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
	move.w d0,d7	;sauvegarde la fonte
	move.w (a6)+,d2
	move.w (a6)+,d3
	movem.w (a5),d0-d1	;recouvre x1 et y1
	add.w d2,d0
	add.w d3,d1
	WriteStrA d0,d1,#4,(a6)
	move.w d7,-(a7)
	jsr tios::FontSetSys
	addq.l #2,a7
	movem.l (a7)+,d0-d7/a0-a6
	RTS

graphlib@0016
clear_dialog:
	movem.l d0-d4/a5,-(a7)
	lea dialogpos(pc),a5
	movem.w (a5),d0-d3
	moveq #1,d4
	bsr fill
	movem.l (a7)+,d0-d4/a5
	RTS

graphlib@0017
line:
	movem.l d0-d7/a0,-(a7)
	cmp.w d0,d2
	bgt plusl		;prend le point le plus  gauche
	exg d0,d2
	exg d1,d3
plusl:
	move.w d1,d4
	lsl.w #1,d4
	move.w d4,d5
	lsl.w #4,d4
	sub.w d5,d4		;y*30->y
	move.w d0,d5
	lsr.w #3,d5		;x/8->x
	add.w d5,d4
	move.w d0,d5
	not.b d5
	and.b #7,d5		;obtient le pixel  changer
	add.w d4,a0
	bset d5,(a0)
	moveq #1,d6
	lsl.w d5,d6
	move.w d2,d5
	sub.w d0,d5		;pour obtenir la largeur
	moveq #30,d4
	move.w d3,d7
	sub.w d1,d7
	bcc descend
	neg.w d4
	neg.w d7
descend:
	cmp.w d0,d2
	bne pasfini
	cmp.w d1,d3
	beq finil
pasfini:
	cmp.w d5,d7		;plus large ou plus haut ?
	bcc plushaut
pluslarge:
	move.w d5,d2
	subq.w #1,d2
	move.w d7,d3
	sub.w d5,d3
	lsl.w #1,d3	;asl ?
	lsl.w #1,d7
	sub.w d7,d5
	neg.w d5
colonneloop:
	tst.w d5
	bmi pointdroite
	add.w d4,a0
	add.w d3,d5
	bra changecolonne
pointdroite:
	add.w d7,d5
changecolonne:
	ror.b #1,d6
	bcc OKoctet
	addq.l #1,a0
OKoctet:
	or.b d6,(a0)
	dbra d2,colonneloop
	bra finil
plushaut:
	move.w d7,d3
	subq.w #1,d3
	move.w d5,d2
	sub.w d7,d2
	lsl.w #1,d2
	lsl.w #1,d5
	sub.w d5,d7
	neg.w d7
ligneloop:
	tst.w d7
	bmi pointbas
	ror.b #1,d6
	bcc memeoctet
	addq.l #1,a0
memeoctet:
	add.w d2,d7
	bra changeligne
pointbas:
	add.w d5,d7
changeligne:
	add.w d4,a0
	or.b d6,(a0)
	dbra d3,ligneloop
finil:
	movem.l (a7)+,d0-d7/a0
	RTS

graphlib@0018
erase_rect:
	movem.l d0-d4/a6,-(a7)
	lea 28(a7),a6
	move.w (a6)+,d0
	move.w (a6)+,d1
	move.w (a6)+,d2
	move.w (a6)+,d3

	sub.w d0,d2		;largeur
	sub.w d1,d3		;hauteur
	moveq #1,d4		;en blanc
	bsr fill

	movem.l (a7)+,d0-d4/a6
	RTS

graphlib@0019
frame_rect:
	movem.l d0-d5/a6,-(a7)
	lea 32(a7),a6
	move.w (a6)+,d0
	move.w (a6)+,d1
	move.w (a6)+,d4
	move.w (a6)+,d5

	sub.w d0,d4		;largeur
	sub.w d1,d5		;hauteur
	bsr frame

	movem.l (a7)+,d0-d5/a6
	RTS

graphlib@001A
getlength:
;Input:	a0 = string
;Output:	d3 = length
;		d4 = heigth

	movem.l d0-d2/a0-a2,-(a7)
	clr.w d3
	jsr tios::FontGetSys
	lea tios::font_small,a1
loopgetlength:
	tst.b (a0)
	beq fingetlength

	tst.b d0
	beq small
	cmp.b #1,d0
	beq medium
large:
	moveq #10,d4
	addq.w #8,d3
	bra finloop
medium:
	moveq #8,d4
	addq.w #6,d3
	bra finloop
small:
	moveq #5,d4
	clr.l d2		;pour la multiplication
	move.b (a0),d2
	mulu.w #6,d2
	add.b 0(a1,d2.w),d3
finloop:
	addq.l #1,a0
	bra loopgetlength
fingetlength:
	movem.l (a7)+,d0-d2/a0-a2
	RTS

screen:
	tst.w choosescreen
	bne nochange
	move.l plane0(pc),a1
nochange:
	RTS

;*****************************************************

int_1_g4:

	move.w #$2700,sr

	subq.w #1,vbl_phase
	bne int_1_skip

	movem.l d0-d7/a0-a6,-(a7)

	lea vbl_phase(pc),a0
	move.w #3,(a0)+

	tst.w (a0)		;phase
	beq lightplane

	addq.w #1,(a0)
	cmp.w #2,(a0)
	beq darkplane

	clr.w (a0)
	bra copywrap

darkplane:
	move.l plane0,a0
	bra copyplane

lightplane:
	addq.w #1,(a0)
	move.l plane1,a0

copyplane:
	lea	LCD_MEM,a1

	tst.b CALCULATOR
	bne screen92

	moveq #99,d0
copyscreenloop:
	move.l (a0)+,(a1)+		;inutile de faire movem sur les 89
	move.l (a0)+,(a1)+		;116 cycles pour une ligne!
	move.l (a0)+,(a1)+
	move.l (a0)+,(a1)+
	move.l (a0)+,(a1)+
	lea 10(a0),a0
	lea 10(a1),a1
	dbra d0,copyscreenloop

	bra copywrap

screen92:
	moveq #79,d0		;48*80=3840
copy92:
	movem.l (a0)+,d1-d7/a2-a6
	movem.l d1-d7/a2-a6,(a1)
	lea 48(a1),a1
	dbra d0,copy92

copywrap:
        movem.l (a7)+,d0-d7/a0-a6	;restore registers from stack
int_1_skip:
        move.l  oldint1(pc),-(a7)	        ;put old auto-int 1 address on stack
	rts                             ;  and run it (will return itself)


;*****************************************************
; miscellaneous program data
;*****************************************************

graphlib@0011
plane0		dc.l $4C00
graphlib@0012
plane1		dc.l 0
graphlib@0013
plane2		dc.l 0
graphlib@000D
choosescreen	dc.w 0
handle		dc.w 0
dummyhandle		dc.w 0
dialogpos		ds.w 4
oldint1		dc.l 0
vbl_phase	dc.w	3
phase		dc.w	0
table		ds.w	6
	end