	include "tios.h"
	include "graphlib.h"
	include "filelib.h"
	include "ziplib.h"

	xdef _library
	xdef _ti89
	xdef _ti92plus

	xdef userlib@0000		;idle_loop
	xdef userlib@0001		;random
	xdef userlib@0002		;rand_seed
	xdef userlib@0003		;Exec
	xdef userlib@0004		;FindSymEntry
	xdef userlib@0005		;DrawCharXY
	xdef userlib@0006		;InputStr
	xdef userlib@0007		;getpassword
	xdef userlib@0008		;changepass
	xdef userlib@0009		;lockcalc
	xdef userlib@000A		;idle_hot
	xdef userlib@000B		;getfreeRAM
	xdef userlib@000C		;smallmenu
	xdef userlib@000D		;getfreearchive
	xdef userlib@000E		;set_APD
	xdef userlib@000F		;get_APD
	xdef userlib@0010		;runprog	;waiting for TI's doc


idle_loop:
userlib@0000:
	movem.l d1-d7/a0-a6,-(a7)
	move.w #2,-(a7)
keyloop:
	jsr tios::OSTimerExpired	;regarde si timer expir
	tst.w d0
	beq pasteindre
teindre:
	trap #4
pasteindre:

	jsr tios::kbhit			;lit le numro de touche
	tst.w d0
	beq keyloop

	jsr tios::ngetchx			;convertit si appuy longtemps
	cmp.w #KEY_DIAMOND+$10B,d0
	beq teindre

	move.w d0,d6

	addq.w #1,(a7)
	jsr tios::ST_busy

	move.w d6,d0

	addq.l #2,a7

	movem.l (a7)+,d1-d7/a0-a6
	RTS

random:
userlib@0001:
	move.l  d1,-(a7)
	move.w	rand_seed(pc),d1
	mulu.w	#31421,d1
	add.w		#6927,d1
	mulu.w	d1,d0
	move.w	d1,rand_seed
	clr.w	d0
	swap	d0
	move.l  (a7)+,d1
	RTS

userlib::exec
userlib@0003:
	move.w 4(a7),d0	;handle
	DEREF d0,a3		;adresse
	clr.l d1
	move.w (a3),d1	;taille
	lea	1(a3,d1.l),a2	;pointe sur le genre

	cmp.b		#$F8,(a2)	; is it 'OTHER' ?
	bne		\testASM	; no then check if it's ASM
	tst.b		2(a3)		; type = ASM ?
	bne		\Fail

	move.w		4(a7),d2
	jsr		filelib::hdltoindex	; gets the file index and folder handle
;	tst.l		d0		; if compressed and file isn't in VAT
;	beq		\Fail

	DEREF	d0,a0		;adresse du folder
	mulu.w	#14,d1
	addq.w	#4,d1
	add.w	d1,a0		; VAT address of the file
	moveq		#1,d0	; semi-comment mode

	cmp.l	#$200000,a3
	bge	\ziparch

; ici : compress / non archiv
	jsr	ziplib::zipfile	; unzips file / semi-comment mode
	tst.b		d0		; couldn't unzip
	bne	\Fail
	move.w		12(a0),d0
	clr.w	-(a7)		; there's no handle to be freed later
	move.w	d0,-(a7)	; means the file is to be zipped back
	bra		\endcomp
\ziparch
; ici : compress / archiv
	jsr	ziplib::tempfile
	tst.b	d0
	bne	\Fail
	move.w	d1,d0
	move.w d0,-(a7)	; pushes the handle of the temp block for future use
	move.w	#1,-(a7)	; means the handle is to be freed at the end

\endcomp
	DEREF		d0,a0
	bra		\rel

\testASM
	cmp.b		#$F3,(a2)	; is it an ASM ?
	bne		\Fail		; no -> bye !

	cmp.l #$200000,a3
	blt \notarchived

;temporary unarchive an unarchived prog
	clr.l d3
	move.w	(a3),d3
	addq.l #3,d3
	move.l d3,-(a7)
	jsr tios::HeapAlloc	; allocates a block to copy from Archive memory
	addq.l	#4,a7

	tst.w d0
	beq \Fail

	move.w d0,-(a7)	; pushes the handle of the temp block for future use
	move.w	#1,-(a7)	; means the handle is to be freed at the end

	DEREF d0,a0
	move.l a0,a5	; a5 : destination

	subq.l #1,d3
\cpy
	move.b (a3)+,(a5)+	; copy to RAM
	dbra d3,\cpy
	bra \rel

\notarchived
	move.l	a3,a0

	clr.l	-(a7)	; means that there is nothing to do at the end :)

\testcomp

; a0 : adresse du debut du prog
\rel
	lea 2(a0),a5
	cmp.l	#"68kP",4(a5)
	bne	\format
	tst.w	8(a5)
	bne	\inuse

	jsr (a5)
\afterexec
; a partir d'ici, sauver d0

	move.w	(a7)+,d1	; what is to do now ?
	move.w	(a7)+,d2	; get the saved handle
	tst.w	d1
	beq	\Fail		; nothing -> end
	cmp.w	#1,d1		; 
	bne	\zipback
	move.l d0,-(a7)
	move.w d2,-(a7)
	jsr tios::HeapFree
	addq.l #2,a7
	move.l (a7)+,d0
\Fail	rts

\zipback		; have to zip the file back

	move.l	d0,d4

	move.w	d1,d2
	jsr	filelib::hdltoindex	; gets the file index and folder handle
	tst.l	d0		; if compressed and file isn't in VAT
	beq	\notfnd

	DEREF	d0,a0
	mulu.w	#14,d1
	addq.w	#4,d1
	add.w	d1,a0		; VAT address of the file
	moveq		#1,d0	; semi-comment mode
	jsr	ziplib::zipfile ; zip it back
\notfnd
	move.l	d4,d0
	rts
\inuse
	moveq #5,d0
	bra	\afterexec
\format
	moveq #4,d0
	bra	\afterexec

	RTS

userlib::FindSymEntry
userlib@0004:
	jmp filelib::FindSymEntry

userlib::DrawCharXY
userlib@0005:
;util::DrawCharXY(BYTE ch,WORD x,WORD y,WORD color)
	lea		charstr(pc),a0
	move.b	5(a7),(a0)
	move.w	10(a7),-(a7)
	move.l	a0,-(a7)
	move.l	12(a7),-(a7)
	jsr	tios::DrawStrXY
	lea	10(a7),a7
	RTS

userlib@0006:
;Input:	d1.w = x
;	d2.w = y
;	d3.w = maxchar
;Output: d0.w = string lenght
;	 a0.l = adress of the string

	move.l d6,-(a7)
	moveq #1,d6
	bsr InputStr
	move.l (a7)+,d6
	RTS

InputStr:
	movem.l d1-d7/a1-a6,-(a7)

	move.b	#1,tios::MaxHandles+$24+$11	;ALPHA LOCK

	lea temp,a0			;a0=adresse de la chaine
Clear:
	move.l a0,a6
	lea 20(a0),a1		;pour les toiles
	clr.w d4			;part de 0 caractre
loop:
	clr.b (a6)			;termine la chaine par un 0 pour pouvoir l'afficher
	clr.b (a1)
	bsr print
	bsr idle_loop
	cmp.w	  #13,d0		;Enter ?
	beq	  Enter
	cmp.w   #263,d0		;Clear ?
	beq     Clear
	cmp.w   #257,d0		;Backspace ?
	beq     Del
	cmp.w   #264,d0		;ESC ?
	beq     Esc
	cmp.w   #255,d0		;Charactre invalide ?
	bhi     loop
	cmp.w   d3,d4		;Maxchar ?
	beq     loop
	move.b d0,(a6)+
	move.b #'*',(a1)+
	addq.w #1,d4
	bra loop
Del:
	tst.w d4
	beq loop
	subq.w #1,d4
	clr.b -(a6)
	clr.b -(a1)
	bra loop
Esc:
	clr.w d4
	clr.b (a0)
Enter:
	move.w d4,d0
	movem.l (a7)+,d1-d7/a1-a6
	RTS

print:		;a0=adresse de chaine  afficher
	movem.l d0-d7/a0-a6,-(a7)
	move.w d1,d0	;x
	move.w d2,d1	;y
	move.w d3,d2
	subq.w #1,d2
	lsl.w #3,d2		;largeur
	moveq #7,d3		;hauteur
	moveq #1,d4		;en blanc
	jsr graphlib::fill

	move.w #4,-(a7)
	move.l a0,-(a7)
	tst.w d6
	bne notstars
	add.l #20,(a7)
notstars:
	move.w d1,-(a7)
	move.w d0,-(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7

	movem.l (a7)+,d0-d7/a0-a6
	RTS

userlib@0007:
getpassword:
	movem.l d0/d2-d7/a0-a6,-(a7)
	clr.w		-(a7)
	jsr		tios::FontSetSys
	addq.l	#2,a7
	lea		mpass(pc),a0
	jsr		graphlib::smallbox
	lea entpass(pc),a0
	tst.b CALCULATOR
	beq TI89
	WriteStrA #53,#44,#4,a0
	moveq #63,d1
	moveq #59,d2
	moveq #10,d3
	bra TI92
TI89:
	WriteStrA #40,#38,#4,a0
	moveq #50,d1
	moveq #48,d2
	moveq #10,d3
TI92:
	clr.l d6
	bsr InputStr
	move.l a0,-(a7)
	pea password(pc)
	jsr tios::strcmp
	addq.l #8,a7
	move.w d0,d1
	movem.l (a7)+,d0/d2-d7/a0-a6
	RTS

userlib@0008:
changepass:
	movem.l	d0-d7/a0-a6,-(a7)
	bsr		getpassword
	tst.w		d1
	bne		exit
	clr.w		-(a7)
	jsr		tios::FontSetSys
	addq.l	#2,a7
	clr.l		d6		;pour afficher des toiles
	moveq		#10,d3	;pour que Input demande 10 letrres
	lea		newpass(pc),a0
	tst.b		CALCULATOR
	beq		change89
	WriteStrA	#53,#44,#4,a0
	moveq		#63,d1
	moveq		#59,d2
	bra change92
change89:
	WriteStrA	#40,#38,#4,a0
	moveq		#50,d1
	moveq		#48,d2
change92:
	bsr InputStr
	lea		40(a0),a1		;pour avoir newpasstemp
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	lea		confirm(pc),a0
	tst.b		CALCULATOR
	beq		confirm89
	WriteStrA	#53,#71,#4,a0
	moveq		#63,d1
	moveq		#84,d2
	bra confirm92
confirm89:
	WriteStrA	#40,#60,#4,a0
	moveq		#50,d1
	moveq		#70,d2
confirm92:
	bsr InputStr
	lea		40(a0),a1		;pour avoir newpasstemp
	movem.l	a0-a1,-(a7)
	jsr		tios::strcmp
	movem.l	(a7)+,a0-a1

	tst.w d0
	bne exit

	lea		password(pc),a1
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
exit:
	movem.l	(a7)+,d0-d7/a0-a6
	RTS


newint6:	RTE

userlib@0009
lockcalc:
;sauve l'ecran
	movem.l	d0-d7/a0-a6,-(a7)

	lea $40078,a6
	move.l (a6),d7		;dsactive l'auto-int6
	move.l #newint6,(a6)	;pour ne pas quitter avec [ESC]+[ON]

	clr.w		d0
	clr.w		d1
	move.w	#LCD_LINE_BYTES,d2
	move.w	#LCD_HEIGHT,d3
	jsr		graphlib::scrtomem
;brouille l'cran
off:
	movem.l	d0-d4,-(a7)
	lea 		LCD_MEM,a0
	move.w	#3840/2-1,d2
brouille:
	moveq.w	#-1,d0
;	move.w	#$FFFF,d0
	bsr		random
	move.w	d0,(a0)+
	dbra		d2,brouille
	movem.l	(a7)+,d0-d4
	trap		#4

;demande le mot de passe
	bsr		getpassword
	tst.l		d1
	bne		off
	clr.w		d1
	jsr		graphlib::memtoscr

	move.l d7,(a6)

	movem.l	(a7)+,d0-d7/a0-a6
	RTS

userlib@000A:
idle_hot:
	bsr	idle_loop
	tst.b	CALCULATOR
	beq	hot89

	cmp.w #274,d0	;F7
	beq hotlock
	cmp.w #275,d0	;F8
	beq hotoff
	RTS

hot89:
	cmp.w #277,d0	;Home
	beq hotlock
	cmp.w #266,d0	;Mode
	beq hotoff
	RTS

hotlock:
	bsr lockcalc
	bra idle_hot
hotoff:
	trap #4
	bra idle_hot

userlib@000B
getfreeRAM:
;renvoie dans d0 la memoire libre
	movem.l	d1-d7/a0-a6,-(a7)
	jsr tios::HeapAvail
	movem.l	(a7)+,d1-d7/a0-a6
	RTS

userlib@000C
smallmenu:
;Input:
;	d0.w = x
;	d1.w = y
;	d2.b = nbitem
;	a0.l = string list; adding an extra null byte between 2 strings will force
;		smallmenu to draw an horizontal line.
;Output:
;	d0.w = Selected Item
;	d1.w = Last key pressed
;	d2.w = 0  -> ENTER pressed
;		Otherwise, another key has been pressed

	movem.l d3-d7/a0-a6,-(a7)

	clr.l d5		;longueur maximale

	movem.l d2/a0,-(a7)
	subq.w #1,d2	;pour DBRA

longmax:
	tst.b (a0)		;si ligne
	bne longsuite
	addq.l #1,a0
longsuite:
	jsr graphlib::getlength		;d3=largeur, d4=hauteur(constante)
longloop:
	tst.b (a0)+
	bne longloop

	cmp.w d5,d3
	blt reste
	move.w d3,d5
reste:
	dbra d2,longmax

	movem.l (a7)+,d2/a0

	move.w d4,d6
	move.w d5,d7
	addq.w #5,d6	;mme marge que DoorsOs pour mme apparence
	addq.w #5,d7

	mulu.w d2,d6	;hauteur du menu

	movem.w d0-d2,-(a7)

	lsr.w #3,d0		;X en octets

	move.w d6,d3
	addq.w #1,d3	;pour viter barre blanche

	move.w d7,d2
	lsr.w #3,d2		;largeur en octets
	addq.w #2,d2	;sinon les bords sont coups

	jsr graphlib::scrtomem

	movem.w d0-d4,-(a7)
	movem.w 10(a7),d0-d2

	divu.w d2,d6	;hauteur d'un menu
	move.w d7,d2	;largeur du cadre
	subq.w #2,d3	;pour viter que fill s'tale...
	moveq #1,d4		;en blanc
	jsr graphlib::fill

	move.w d2,d4
	move.w d3,d5
	addq.w #1,d5
	jsr graphlib::frame

;affiche maintenant tous les titres

	movem.w 10(a7),d0-d2	;pour restaurer d2
	subq.w #1,d2

loopligne:
	tst.b (a0)
	bne texte

	move.w d2,-(a7)
	move.w d0,d2	;x1 en d2
	add.w d7,d2		;+largeur-> x2
	jsr graphlib::horiz
	move.w (a7)+,d2
	addq.l #1,a0

texte:
	movem.l d0-d7/a0-a6,-(a7)
	addq.w #2,d0
	addq.w #3,d1
	WriteStrA d0,d1,#4,a0
	movem.l (a7)+,d0-d7/a0-a6

suivant:
	tst.b (a0)+
	bne suivant

	add.w d6,d1
	dbra d2,loopligne

	move.w d6,d3
	subq.w #2,d3
	movem.w 10(a7),d0-d2

	move.w d2,d5
	move.w d7,d2

	subq.w #2,d2	;largeur
	addq.w #1,d0
	addq.w #1,d1
	clr.w d4		;couleurs inverses

	move.w #1,a6	;se sert d'a6 comme d'un 9me registre!

choixloop:
	jsr graphlib::fill

	move.w d0,d7	;sauvegarde d0 (dtruit par idle_loop)
	bsr idle_hot
	exg.w d0,d7

	jsr graphlib::fill

	cmp.w #KEY_UP,d7
	bne pashaut

	cmp.w #1,a6
	bne pasmin
	move.w d5,a6
	move.w d5,d7
	subq.w #1,d7
	mulu.w d6,d7
	add.w d7,d1
	bra choixloop
pasmin:
	subq.w #1,a6
	sub.w d6,d1		;fait monter le menu
	bra choixloop
pashaut:
	cmp.w #KEY_DOWN,d7
	bne pasbas

	cmp.w a6,d5
	bne pasmax
	move.w #1,a6
	move.w d5,d7
	subq.w #1,d7
	mulu.w d6,d7
	sub.w d7,d1
	bra choixloop
pasmax:
	addq.w #1,a6
	add.w d6,d1		;fait descendre le menu
	bra choixloop

pasbas:

	movem.w (a7)+,d0-d4
	addq.l #6,a7

	jsr graphlib::memtoscr

;Est-ce que d7=chiffre ?

	move.w d7,d6
	sub.w #'0',d6	;pour obtenir le code de la touche
	ble paschiffre
	cmp.w d5,d6
	bgt paschiffre
	move.w d6,a6
	clr.w d2		;un menu a t choisi

paschiffre:
	move.w a6,d0
	move.w d7,d1
	cmp.w #13,d1
	bne pasenter
	clr.w d2
pasenter:
	movem.l (a7)+,d3-d7/a0-a6
	RTS

userlib@000D
getfreearchive:
	movem.l	d1-d7/a0-a6,-(a7)
	clr.l -(a7)
	clr.l -(a7)
	pea archive(pc)
	pea archive+4(pc)
	clr.l -(a7)
	jsr tios::EM_survey
	lea 20(a7),a7
	move.l (a0)+,d0
	add.l (a0),d0
	movem.l	(a7)+,d1-d7/a0-a6
	RTS

userlib@000E
set_apd:
;Input: d0.w = new_APD
	movem.l	d0-d7/a0-a6,-(a7)
	clr.l		d7
	move.w	d0,d7		;conserve le mot
	move.w	#2,-(a7)
	jsr		tios::OSFreeTimer		;remet  0
	mulu.w	#20,d7
	move.l	d7,-(a7)
	move.w	#2,-(a7)
	jsr		tios::OSRegisterTimer
	addq.l	#8,a7
	movem.l	(a7)+,d0-d7/a0-a6
	RTS

userlib@000F
get_apd:
	movem.l	d1-d7/a0-a6,-(a7)
	move.w	#$700,d0
	trap		#1
	move.w	#2,-(a7)
	jsr		tios::OSTimerRestart
	jsr		tios::OSTimerCurVal
	addq.l	#2,a7
	move.w	d0,d1
	divu.w	#20,d1
	clr.w		d0
	trap		#1
	move.w	d1,d0
	movem.l	(a7)+,d1-d7/a0-a6
	RTS

userlib@0010
runprog:


	RTS

;*****************************************************
; miscellaneous program data
;*****************************************************

archive	ds.l 2
userlib@0002:
rand_seed	dc.w 0
charstr	dc.b 0,0
mpass		dc.b "Password Protection",0
password	dc.b "doors",0,0,0,0,0,0,0		;12 pour multiple de 4
entpass	dc.b "Enter current password:",0
newpass	dc.b "Enter the new password:",0
confirm	dc.b "Confirm the password:",0

	BSS

temp	ds.b 20		;utilis pour InputStr
temp2 ds.b 20		;pour les toiles
newpasstemp ds.b	12
	end